//
//  ViewController.swift
//  WLHiddenNav
//
//  Created by wangguoliang on 16/6/30.
//  Copyright © 2016年 wangguoliang. All rights reserved.
//

import UIKit

class ViewController: UIViewController,UITableViewDelegate,UITableViewDataSource {

    var wlTableView: UITableView!
    var lastContentoffset : CGFloat!
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        self.edgesForExtendedLayout = .None
        
        self.wlTableView = UITableView(frame: self.view.bounds, style: .Plain)
        self.wlTableView.delegate = self
        self.wlTableView.dataSource = self
        self.view.addSubview(self.wlTableView)
        self.lastContentoffset = 0.0
        //self.navigationController?.hidesBarsOnSwipe = true
    }

    // 第一种方法
    @available(iOS 8.0, *)
    func navHiddenForiOS8() {
        self.navigationController?.hidesBarsOnSwipe = true
    }
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

}

// MARK: UITableViewDataSource
extension ViewController {
    func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return 100
    }
    
    func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell
    {
        let  identifier = "wlTableViewCell"
        
        var cell = tableView.dequeueReusableCellWithIdentifier(identifier)
        
        if cell == nil {
            cell = UITableViewCell(style: .Default, reuseIdentifier: identifier)
        }
        cell?.textLabel?.text = String(indexPath.row)
        cell?.selectionStyle = .None
        return cell!
    }
}


// MARK: UIScrollViewDelegate
extension ViewController {
    
    // 第二种方法
    func scrollViewDidScroll(scrollView: UIScrollView) {
        
        let pan = scrollView.panGestureRecognizer
        let velocity = pan.velocityInView(scrollView).y
        if velocity < -5 {
            self.navigationController?.setNavigationBarHidden(true, animated: true)
        } else if velocity > 5 {
            self.navigationController?.setNavigationBarHidden(false, animated: true)
        }
        
    }
    
    // 第三种方法
//    func scrollViewWillEndDragging(scrollView: UIScrollView, withVelocity velocity: CGPoint, targetContentOffset: UnsafeMutablePointer<CGPoint>) {
//        if velocity.y > 0 {
//            self.navigationController?.setNavigationBarHidden(true, animated: true)
//        } else if velocity.y < 0 {
//            self.navigationController?.setNavigationBarHidden(false, animated: true)
//        }
//    }
}

// 第四种方法
/*
 //self.lastContentoffset上一次滑动的距离
 if (scrollView.contentOffset.y > 0) {
 if(scrollView.contentOffset.y-self.lastContentoffset<=0) {
 self.navigationController?.setNavigationBarHidden(false, animated: true)
 } else {
 self.navigationController?.setNavigationBarHidden(true, animated: true)
 }
 } else {
 self.navigationController?.setNavigationBarHidden(false, animated: true)
 }
 self.lastContentoffset = scrollView.contentOffset.y;
 */

